﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.ComponentModel; // Sortieren SortDescriptions

namespace FM4500 {
    public class FileItem : IComparable<FileItem> {
        public enum FileinfoTyp { Name, Ext, LastTime, Size };

        public static FileinfoTyp sortType = FileinfoTyp.Name;
        public static ListSortDirection direction = ListSortDirection.Ascending;

        private String fullname = "";
        private String filename = "";
        private String ext = "";
        private DateTime createTime;
        private DateTime lastTime;
        private long size = 0;
        private bool directory = false;


        public FileItem(FileItem fileItem) {
            fullname = fileItem.Fullname;
            filename = fileItem.Filename;
            ext = fileItem.Ext;
            createTime = fileItem.CreateTime;
            lastTime = fileItem.LastTime;
            size = fileItem.Size;
            directory = fileItem.Directory;
        }
        // public string Fullname { get; set; }

        public FileItem(bool directory) {
            this.directory = directory;
        }


        public String Fullname {
            get { return fullname; }
            set { fullname = value; }
        }
        public String Filename {
            get { return filename; }
            set { filename = value; }
        }
        public String Ext {
            get {
                if (ext.Length == 0)
                    return "";
                else
                    return ext.Substring(1).ToUpper();
            }
            set { ext = value; }
        }
        public String StringSize {
            get {
                if (size == 0)
                    return "";
                else
                    return Basis.Long_Str_Komma(size);
            }
        }
        public long Size {
            get { return size; }
            set { size = value; }
        }
        public DateTime CreateTime {
            get { return createTime; }
            set { createTime = value; }
        }
        public DateTime LastTime {
            get { return lastTime; }
            set { lastTime = value; }
        }
        public bool Directory {
            get { return directory; }
            set { directory = value; }
        }
        public String isDirectory {
            get {
                if (directory)
                    return "Dir";
                else
                    return "";
            }
        }


        public int CompareTo(FileItem other) {
            int retcode = 0;
            if (directory && !other.directory) {
                // I'm am a directory, the param not
                return -1;
            }
            else {
                if (!directory && other.directory) {
                    // I'm am not a directory, the param is a directoy
                    return +1;
                }
                else {
                    // I'm am a directory, the param is also a directoy
                    if (directory && other.directory) {
                        if (filename.Equals(Konstanten.C_TOP_DIR)) return -1;
                        if (other.filename.Equals(Konstanten.C_TOP_DIR)) return +1;
                        switch (sortType) {
                            case FileinfoTyp.Name: retcode = filename.CompareTo(other.filename); break;
                            case FileinfoTyp.Ext: retcode = ext.CompareTo(other.ext); break;
                            case FileinfoTyp.LastTime: retcode = lastTime.CompareTo(other.lastTime); break;
                            case FileinfoTyp.Size: retcode = 0; break;
                        }
                    }
                    else {
                        // I'm am not a directory, the param is also not a directoy
                        switch (sortType) {
                            case FileinfoTyp.Name: retcode = filename.CompareTo(other.filename); break;
                            case FileinfoTyp.Ext: retcode = ext.CompareTo(other.ext); break;
                            case FileinfoTyp.LastTime: retcode = lastTime.CompareTo(other.lastTime); break;
                            case FileinfoTyp.Size: retcode = size.CompareTo(other.size); break;
                        }
                    }
                    // if the sort is ascending, multiplication with -1
                    if (direction != ListSortDirection.Ascending)
                        retcode = -retcode;
                }
            }
            return retcode;
        }

    }
}
